// CADlg.cpp : implementation file
//

#include "stdafx.h"
#include "CACol.h"
#include "CADlg.h"
#include <math.h>

#include "cximage580_src\CxImage\ximage.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

//////////////////////////////////////////////////////////////////////////////
// Cellular automata specific functions

COLORREF s[2]={RGB(255,255,255),RGB(0,0,0)};

const COLORREF CCADlg::m_cMask=RGB(255,255,192);

COLORREF CCADlg::f(COLORREF yL, COLORREF y, COLORREF yR)
{
	int i=((yL==s[1])?4:0)+((y==s[1])?2:0)+((yR==s[1])?1:0);
	bool b;
	if (i==0) b=m_b000?true:false; else
	if (i==1) b=m_b001?true:false; else
	if (i==2) b=m_b010?true:false; else
	if (i==3) b=m_b011?true:false; else
	if (i==4) b=m_b100?true:false; else
	if (i==5) b=m_b101?true:false; else
	if (i==6) b=m_b110?true:false; else
	if (i==7) b=m_b111?true:false;
	return s[b?1:0];
}

void CCADlg::init()
{
	for (WORD ww=0; ww<MAXX; ww++) for (WORD wh=0; wh<MAXY; wh++) {
		Field[ww][wh]=s[0];
	}
	Field[MAXX/2][0]=s[1];
}

/////////////////////////////////////////////////////////////////////////////
// CCADlg dialog

CCADlg::CCADlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCADlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCADlg)
	m_bRed = 0;
	m_bGreen = 0;
	m_bBlue = 0;
	m_bMask = FALSE;
	m_b000 = FALSE;
	m_b001 = FALSE;
	m_b010 = FALSE;
	m_b011 = FALSE;
	m_b100 = FALSE;
	m_b101 = FALSE;
	m_b110 = FALSE;
	m_b111 = FALSE;
	m_iVal = 0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_bPressed=false;
	m_bDraging=false;
	m_bZoom=1;
	m_wYOffset=0;
	m_wXOffset=0;
	m_brBrush.CreateSolidBrush(RGB(255,0,255));
}

void CCADlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCADlg)
	DDX_Control(pDX, IDC_METRIX, m_sMetrix);
	DDX_Text(pDX, IDC_ERED, m_bRed);
	DDX_Text(pDX, IDC_EGREEN, m_bGreen);
	DDX_Text(pDX, IDC_EBLUE, m_bBlue);
	DDX_Check(pDX, IDC_MASK, m_bMask);
	DDX_Check(pDX, IDC_B000, m_b000);
	DDX_Check(pDX, IDC_B001, m_b001);
	DDX_Check(pDX, IDC_B010, m_b010);
	DDX_Check(pDX, IDC_B011, m_b011);
	DDX_Check(pDX, IDC_B100, m_b100);
	DDX_Check(pDX, IDC_B101, m_b101);
	DDX_Check(pDX, IDC_B110, m_b110);
	DDX_Check(pDX, IDC_B111, m_b111);
	DDX_Text(pDX, IDC_VALUE, m_iVal);
	DDV_MinMaxInt(pDX, m_iVal, 0, 255);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CCADlg, CDialog)
	//{{AFX_MSG_MAP(CCADlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_COLOR, OnColor)
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_BN_CLICKED(IDC_STEP, OnStep)
	ON_BN_CLICKED(IDC_RESET, OnReset)
	ON_BN_CLICKED(IDC_AUTO, OnAuto)
	ON_BN_CLICKED(IDC_ZOOMPLU, OnZoomplu)
	ON_BN_CLICKED(IDC_ZOOMMIN, OnZoommin)
	ON_WM_RBUTTONDOWN()
	ON_WM_RBUTTONUP()
	ON_BN_CLICKED(IDC_MASK, OnMask)
	ON_EN_CHANGE(IDC_VALUE, OnChangeValue)
	ON_BN_CLICKED(IDC_B000, OnB)
	ON_BN_CLICKED(IDC_SAVE, OnSave)
	ON_BN_CLICKED(IDC_B001, OnB)
	ON_BN_CLICKED(IDC_B010, OnB)
	ON_BN_CLICKED(IDC_B011, OnB)
	ON_BN_CLICKED(IDC_B100, OnB)
	ON_BN_CLICKED(IDC_B101, OnB)
	ON_BN_CLICKED(IDC_B110, OnB)
	ON_BN_CLICKED(IDC_B111, OnB)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCADlg message handlers

BOOL CCADlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString s1,s2;
		s1.LoadString(IDS_GENERATE);
		s2.LoadString(IDS_ABOUTBOX);
		if (!s1.IsEmpty() && !s2.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_GENERATE, s1);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, s2);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// Lets init rectangular workspace
	GetDlgItem(IDC_FIELD)->GetClientRect(m_rField);
	m_wFHeight=m_rField.bottom-5;
	m_wFWidth=m_rField.right-5;

	GetDlgItem(IDC_FIELD)->GetWindowRect(m_rField);
	ScreenToClient(m_rField);
	m_rField.InflateRect(-3,-3);
	m_rField.OffsetRect(-1,-1);

	CString s;
	GetWindowText(s);
	CString str;
	str.Format(" - %dx%d cells",m_wFWidth,m_wFHeight);
	SetWindowText(s+str);

	CClientDC dc(this);
	m_dcField.CreateCompatibleDC(&dc);
	m_bField.CreateCompatibleBitmap(&dc,m_wFWidth,m_wFHeight);
	m_dcField.SelectObject(m_bField);
	m_dcField.FillSolidRect(0,0,m_wFWidth,m_wFHeight,RGB(128,0,128));

	CRect rect;
	GetDlgItem(IDC_PROGRESS)->GetWindowRect(rect);
	ScreenToClient(rect);
	m_pProgress.Create(PBS_SMOOTH|WS_CHILD|WS_VISIBLE,rect,this,ID_DYNCREATE);

	OnReset();

	return TRUE;
}

void CCADlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if (nID==IDM_ABOUTBOX) {
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	} else if (nID==IDM_GENERATE) {
		OnGenerate();
	} else {
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CCADlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this);

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CClientDC dc(this);
		dc.BitBlt(m_rField.left,m_rField.top,m_rField.right-m_rField.left+1,m_rField.bottom-m_rField.top+1,&m_dcField,0,0,SRCCOPY);
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
// the minimized window.
HCURSOR CCADlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CCADlg::OnColor() 
{
	UpdateData(TRUE);
	CColorDialog aCDlg(RGB(m_bRed,m_bGreen,m_bBlue),CC_ANYCOLOR|CC_FULLOPEN);

	if (aCDlg.DoModal()) {
		COLORREF crf=aCDlg.GetColor();
		m_bRed=(BYTE)crf;
		m_bGreen=(BYTE)(crf>>8);
		m_bBlue=(BYTE)(crf>>16);
		UpdateData(FALSE);
	}
}

void CCADlg::OnMouseMove(UINT nFlags, CPoint point) 
{
	if (m_rField.PtInRect(point)) {
		CString s;
		s.Format("(%d;%d)",m_wXOffset+(point.x-m_rField.left)/m_bZoom,m_wYOffset+(point.y-m_rField.top)/m_bZoom);
		if (m_bDraging) s="Drag";
		m_sMetrix.SetWindowText(s);
		if (m_bPressed) PutInCell(point);
	} else {
		m_bDraging=FALSE;
		m_bPressed=FALSE;
		m_sMetrix.SetWindowText("(?;?)");
	}

	CDialog::OnMouseMove(nFlags, point);
}

void CCADlg::OnLButtonDown(UINT nFlags, CPoint point) 
{
	UpdateData(TRUE);
	m_bPressed=true;
	if (m_rField.PtInRect(point) && m_bPressed) PutInCell(point);
	
	CDialog::OnLButtonDown(nFlags, point);
}

void CCADlg::PaintField()
{
	m_dcField.FillSolidRect(0,0,m_wFWidth,m_wFHeight,RGB(255,255,255));
	WORD width=(WORD)ceil(m_wFWidth/m_bZoom);
	WORD height=(WORD)ceil(m_wFHeight/m_bZoom);
	for (WORD ww=0; ww<width; ww++) {
		m_pProgress.SetPos(m_wFWidth+ww*m_bZoom);
		for (WORD wh=0; wh<height; wh++) {
			if (m_bZoom!=1) {
				m_dcField.FillSolidRect(ww*m_bZoom,wh*m_bZoom,m_bZoom,m_bZoom,(m_bMask&&wh+m_wYOffset<=(int)m_wStep%m_wFHeight)?(Field[ww+m_wXOffset][wh+m_wYOffset]==s[0]?m_cMask:Field[ww+m_wXOffset][wh+m_wYOffset]):Field[ww+m_wXOffset][wh+m_wYOffset]);
				if (m_bZoom>5) m_dcField.FrameRect(CRect(ww*m_bZoom,wh*m_bZoom,(ww+1)*m_bZoom+1,(wh+1)*m_bZoom+1),&m_brBrush);
			} else
				m_dcField.SetPixel(ww,wh,(m_bMask&&wh+m_wYOffset<=(int)m_wStep%m_wFHeight)?(Field[ww+m_wXOffset][wh+m_wYOffset]==s[0]?m_cMask:Field[ww+m_wXOffset][wh+m_wYOffset]):Field[ww+m_wXOffset][wh+m_wYOffset]);
		}
	}
}

void CCADlg::OnLButtonUp(UINT nFlags, CPoint point) 
{
	m_bPressed=false;
	
	CDialog::OnLButtonUp(nFlags, point);
}

UINT MakeStep(LPVOID pParam)
{
	((CCADlg*)pParam)->Step();
	((CCADlg*)pParam)->EnableIt(TRUE);
	return 0;
}

void CCADlg::OnStep() 
{
	UpdateData(TRUE);
	EnableIt(FALSE);
	AfxBeginThread(MakeStep,this,THREAD_PRIORITY_ABOVE_NORMAL);
}

void CCADlg::Step() 
{
	WORD ww,wh;

	for (ww=0; ww<m_wFWidth; ww++) {
		m_pProgress.SetPos(ww);
		for (wh=0; wh<m_wFHeight; wh++) {
			Field[ww][TorItY(m_wStep+1)]=f(Field[TorItX(ww-1)][TorItY(m_wStep)],Field[TorItX(ww)][TorItY(m_wStep)],Field[TorItX(ww+1)][TorItY(m_wStep)]);
		}
	}
	m_wStep++;
	PaintField();
	Invalidate(FALSE);

	char ch[10];
	itoa(m_wStep,ch,10);
	GetDlgItem(IDC_STEPNUM)->SetWindowText(ch);

	m_pProgress.SetPos(0);
}

int CCADlg::TorItX(int x)
{
	if (x<0) x+=m_wFWidth;
	if (x>=m_wFWidth) x%=m_wFWidth;
	return x;
	PaintField();
	Invalidate(FALSE);
}

int CCADlg::TorItY(int y)
{
	if (y<0) y+=m_wFHeight;
	if (y>=m_wFHeight) y%=m_wFHeight;
	return y;
}

UINT MakeReset(LPVOID pParam)
{
	((CCADlg*)pParam)->Reset();
	return 0;
}

void CCADlg::OnReset() 
{
	EnableIt(FALSE);
	AfxBeginThread(MakeReset,this,THREAD_PRIORITY_ABOVE_NORMAL);
}

void CCADlg::Reset() 
{
	m_wStep=0;
	m_pProgress.SetRange32(0,m_wFWidth*2);
	init();
	PaintField();
	Invalidate(FALSE);

	GetDlgItem(IDC_STEPNUM)->SetWindowText("0");

	m_pProgress.SetPos(0);
	EnableIt(TRUE);
}

void CCADlg::EnableIt(BOOL b,BOOL IsAuto)
{
	GetDlgItem(IDC_STEP)->EnableWindow(b);
	GetDlgItem(IDC_RESET)->EnableWindow(b);
	GetDlgItem(IDC_ZOOMPLU)->EnableWindow(b);
	GetDlgItem(IDC_ZOOMMIN)->EnableWindow(b);
	GetDlgItem(IDC_ERED)->EnableWindow(b);
	GetDlgItem(IDC_EGREEN)->EnableWindow(b);
	GetDlgItem(IDC_EBLUE)->EnableWindow(b);
	GetDlgItem(IDC_COLOR)->EnableWindow(b);
	GetDlgItem(IDC_B000)->EnableWindow(b);
	GetDlgItem(IDC_B001)->EnableWindow(b);
	GetDlgItem(IDC_B010)->EnableWindow(b);
	GetDlgItem(IDC_B011)->EnableWindow(b);
	GetDlgItem(IDC_B100)->EnableWindow(b);
	GetDlgItem(IDC_B101)->EnableWindow(b);
	GetDlgItem(IDC_B110)->EnableWindow(b);
	GetDlgItem(IDC_B111)->EnableWindow(b);
	GetDlgItem(IDC_VALUE)->EnableWindow(b);
	if (!IsAuto) GetDlgItem(IDC_AUTO)->EnableWindow(b);
}

UINT MakeAuto(LPVOID pParam)
{
	CCADlg* dlg=(CCADlg*)pParam;
	while (((CButton*)dlg->GetDlgItem(IDC_AUTO))->GetCheck()) dlg->Step();
	dlg->EnableIt(TRUE,FALSE);
	return 0;
}

void CCADlg::OnAuto() 
{
	if (((CButton*)GetDlgItem(IDC_AUTO))->GetCheck()) {
		EnableIt(FALSE,TRUE);
		AfxBeginThread(MakeAuto,this,THREAD_PRIORITY_ABOVE_NORMAL);
	} else GetDlgItem(IDC_AUTO)->EnableWindow(FALSE);
}

void CCADlg::OnZoomplu() 
{
	m_bZoom++;
	if (m_bZoom>MAXZOOM) m_bZoom=MAXZOOM; else {
		TestOffsets();
		CString s;
		s.Format("x%d",m_bZoom);
		GetDlgItem(IDC_ZOOM)->SetWindowText(s);

		PaintField();
		Invalidate(FALSE);
		m_pProgress.SetPos(0);
	}
}

void CCADlg::OnZoommin() 
{
	m_bZoom--;
	if (m_bZoom<1) m_bZoom=1; else {
		TestOffsets();
		CString s;
		s.Format("x%d",m_bZoom);
		GetDlgItem(IDC_ZOOM)->SetWindowText(s);

		PaintField();
		Invalidate(FALSE);
		m_pProgress.SetPos(0);
	}
}

void CCADlg::PutInCell(CPoint point)
{
	WORD ww=(point.x-m_rField.left)/m_bZoom;
	WORD wh=(point.y-m_rField.top)/m_bZoom;
	// For 1D only
	if (wh!=m_wStep%m_wFHeight) return;

	Field[m_wXOffset+ww][m_wYOffset+wh]=RGB(m_bRed,m_bGreen,m_bBlue);
	if (m_bZoom!=1) {
		m_dcField.FillSolidRect(ww*m_bZoom,wh*m_bZoom,m_bZoom,m_bZoom,RGB(m_bRed,m_bGreen,m_bBlue));
		if (m_bZoom>5) m_dcField.FrameRect(CRect(ww*m_bZoom,wh*m_bZoom,(ww+1)*m_bZoom+1,(wh+1)*m_bZoom+1),&m_brBrush);
	} else m_dcField.SetPixel(ww,wh,RGB(m_bRed,m_bGreen,m_bBlue));
	Invalidate(FALSE);
}

void CCADlg::OnRButtonDown(UINT nFlags, CPoint point) 
{
	m_bDraging=TRUE;
	m_pntPrev=point;

	CDialog::OnRButtonDown(nFlags, point);
}

void CCADlg::OnRButtonUp(UINT nFlags, CPoint point) 
{
	m_bDraging=FALSE;

	m_wXOffset+=(m_pntPrev.x-point.x)/m_bZoom;
	m_wYOffset+=(m_pntPrev.y-point.y)/m_bZoom;

	TestOffsets();

	PaintField();
	Invalidate(FALSE);
	m_pProgress.SetPos(0);
	
	CDialog::OnRButtonUp(nFlags, point);
}

void CCADlg::TestOffsets()
{
	WORD width=(WORD)ceil(m_wFWidth/m_bZoom);
	WORD height=(WORD)ceil(m_wFHeight/m_bZoom);

	if (m_wXOffset<0) m_wXOffset=0;
	if (m_wXOffset>m_wFWidth-width) m_wXOffset=m_wFWidth-width;
	if (m_wYOffset<0) m_wYOffset=0;
	if (m_wYOffset>m_wFHeight-height) m_wYOffset=m_wFHeight-height;
}

void CCADlg::OnMask() 
{
	UpdateData(TRUE);
	PaintField();
	Invalidate(FALSE);
}

void CCADlg::OnChangeValue() 
{
	UpdateData(TRUE);

	ParceIValBits();
}

void CCADlg::OnB() 
{
	UpdateData(TRUE);

	m_iVal=0;
	if (m_b000) m_iVal+=1;
	if (m_b001) m_iVal+=2;
	if (m_b010) m_iVal+=4;
	if (m_b011) m_iVal+=8;
	if (m_b100) m_iVal+=16;
	if (m_b101) m_iVal+=32;
	if (m_b110) m_iVal+=64;
	if (m_b111) m_iVal+=128;

	UpdateData(FALSE);
}

void CCADlg::OnSave() 
{
	CFileDialog	dlg(FALSE,"png","Picture",OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT|OFN_PATHMUSTEXIST,"Portable Network Graphics Files (*.png)|*.png|All Files (*.*)|*.*||");
	if (dlg.DoModal()==IDOK) {
		Render(0,0,m_wFWidth,m_wFHeight,dlg.GetPathName());
	}
}

void CCADlg::Render(UINT x, UINT y, UINT cx, UINT cy, CString file)
{
	CxImage cxi;
	CDC dc;
	CBitmap bmp;
	// Create buffer drawing stuff
	dc.CreateCompatibleDC(&m_dcField);
	bmp.CreateCompatibleBitmap(&m_dcField,cx,cy);
	dc.SelectObject(bmp);
	dc.BitBlt(0,0,cx,cy,&m_dcField,x,y,SRCCOPY);
	// Create picture and save it
	cxi.CreateFromHBITMAP((HBITMAP)bmp);
	cxi.Save(file,CXIMAGE_FORMAT_PNG);
}

void CCADlg::RenderText(UINT x, UINT y, UINT cx, UINT cy, CString file)
{
	CStdioFile f(file,CFile::modeCreate|CFile::modeWrite|CFile::typeText);
	CString str;
	for (;y<=cy;y++) {
		str="";
		for (UINT xx=x;xx<=x+cx;xx++) {
			if (Field[xx][y]==s[0]) str+='0'; else str+='1';
		}
		str+='\n';
		f.WriteString(str);
	}
	f.Close();
}

void CCADlg::OnGenerate() 
{
	// File name's storage
	CString s;
	CString fn;
	// Generate small pictures
	for (m_iVal=0;m_iVal<256;m_iVal++) {
		// Prepare picture
		ParceIValBits();
		MakeReset(this);
		for (int i=0; i<64; i++) MakeStep(this);
		// Store picture
		s.Format("%d",m_iVal);
		while (s.GetLength()<3) s='0'+s;
		fn.Format("Pics\\%s.png",s);
		Render(MAXX/2-63,0,127,64,fn);
		fn.Format("Pics\\%s.txt",s);
		RenderText(MAXX/2-63,0,127,64,fn);
	}
	// Generate zoomed pictures
	m_wXOffset=(MAXX/2-16);
	for (m_iVal=0;m_iVal<256;m_iVal++) {
		// Prepare picture
		m_bZoom=4;
		ParceIValBits();
		MakeReset(this);
		for (int i=0; i<16; i++) MakeStep(this);
		// Store picture
		s.Format("%d",m_iVal);
		while (s.GetLength()<3) s='0'+s;
		fn.Format("Pics\\%s.zoom.png",s);
		Render(4,0,124,64,fn);
	}
}

void CCADlg::ParceIValBits()
{
	m_b000=(m_iVal&1)?TRUE:FALSE;
	m_b001=(m_iVal&2)?TRUE:FALSE;
	m_b010=(m_iVal&4)?TRUE:FALSE;
	m_b011=(m_iVal&8)?TRUE:FALSE;
	m_b100=(m_iVal&16)?TRUE:FALSE;
	m_b101=(m_iVal&32)?TRUE:FALSE;
	m_b110=(m_iVal&64)?TRUE:FALSE;
	m_b111=(m_iVal&128)?TRUE:FALSE;
	UpdateData(FALSE);
}
